package de.mlessmann.certassist.service;

import de.mlessmann.certassist.openssl.CertificatePasswordProvider;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

@Service
@RequiredArgsConstructor
public class CertificatePasswordProviderImpl implements CertificatePasswordProvider {

    private final PassphraseService passphraseService;

    @Override
    public String generateNewPassword() {
        return PassphraseService.generateNewPassword(16);
    }

    @Override
    public String getPasswordFor(String certificateFingerprint) {
        return passphraseService.readPassphrase("cert:" + certificateFingerprint).getPassphrase();
    }

    @Override
    public void setPasswordFor(String certificateFingerprint, String password) {
        passphraseService.storePassphrase("cert:" + certificateFingerprint, password);
    }
}
